SystemOrganization addCategory: #ARAP!

Morph subclass: #ARAPMorph
	instanceVariableNames: 'shape inputs dragging column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARAP'!

!ARAPMorph class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 12:05'!
newOn: aShape
	^ self new shape: aShape.
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:23'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas translateBy: self position during: [:c |
		shape edges do: [:pair | | dest orig |
			orig := (column at: (pair first - 1) * 2 + 1)@(column at: (pair first - 1) * 2 + 2).
			dest := (column at: (pair second - 1) * 2 + 1)@(column at: (pair second - 1) * 2 + 2).
			c line: orig to: dest width: 2 color: Color gray.
		].
		1 to: shape vertices size do: [:i |
			| p |
			p := (column at: (i - 1) * 2 + 1)@(column at: (i - 1) * 2 + 2).
			c fillRectangle: ((p - 8) extent: 16) color: ((shape handles includes: i) ifTrue: [Color red] ifFalse: [Color black]).
		].
	].! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 13:40'!
handlesMouseDown: evt
	^ true.
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 13:40'!
handlesMouseMove: evt
	^ dragging notNil
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 13:40'!
handlesMouseUp: evt
	^ dragging notNil
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 14:10'!
mouseDown: evt

	| local dist |
	local := evt cursorPoint - self position.
	inputs keysAndValuesDo: [:k :v |
		dist := v dist: local.
		(v dist: local) < 8 ifTrue: [
			dragging := k.
			self]].
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 14:10'!
mouseMove: evt
	| local |
	dragging ifNotNil: [
		local := evt cursorPoint - self position.
		inputs at: dragging put: local.
		column := shape solve2: inputs.
		self changed
	].
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 14:06'!
mouseUp: evt
	super mouseUp: evt.
	dragging := nil.
! !

!ARAPMorph methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 14:05'!
shape: aShape
	shape := aShape.
	inputs := Dictionary new.
	shape handles do: [:h |
		inputs at: h put: (shape vertices at: h)].
	self color: Color white.
	self extent: shape vertices max + (20@20).
	column := Array streamContents: [:c |
		shape vertices do: [:v |
			c nextPut: v x.
			c nextPut: v y]].

! !

Object subclass: #Shape
	instanceVariableNames: 'vertices edges neighbors handles edgeDiffs a1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARAP'!

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 13:57'!
rectangle
	^ self new vertices: self rectangleVertices edges: self rectangleEdges neighbors: self rectangleEdgeNeighbors handles: self rectangleHandles.! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/20/2016 10:24'!
rectangleEdgeNeighbors
	"^ #((1 2 3 0) (1 3 2 5) (1 5 3 0) (2 3 4 1) (2 4 3 0) (3 4 2 5) (3 5 4 1) (4 5 3 0))"


	^ #((1 2 3 0) (2 3 4 1) (3 1 5 2) (3 4 2 5) (4 2 3 0) (4 5 3 0) (5 3 1 4) (1 5 3 0))

	"
	^ #((1 2) (2 3) (3 1) (3 4) (4 2) (4 5) (5 3) (1 5)).
	^ #((1 2) (1 3) (1 5) (2 3) (2 4) (3 4) (3 5) (4 5))."
	
"	^ {0@0. 2@0. 1@1. 2@2. 0@2}"! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 17:15'!
rectangleEdges
	"^ #((1 2) (1 3) (1 5) (2 3) (2 4) (3 4) (3 5) (4 5))."
	^ #((1 2) (2 3) (3 1) (3 4) (4 2) (4 5) (5 3) (1 5)).
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 13:56'!
rectangleHandles
	^ #(1 3 4).
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 18:42'!
rectangleVertices
	^ {10@10. 210@10. 110@110. 210@210. 10@210}
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:19'!
star
	^ self new vertices: self starVertices edges: self starEdges neighbors: self starEdgeNeighbors handles: self starHandles.! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:39'!
starEdgeNeighbors
	^ #((1 7 6 0) (7 2 8 0) (2 8 7 0) (8 3 9 0) (3 9 8 0) (9 4 10 0) (4 10 9 0) (10 5 6 0) (5 6 10 0) (6 1 7 0) (7 6 11 1) (8 7 11 2) (9 8 11 3) (10 9 11 4) (6 10 11 5) (6 11 7 10) (7 11 8 6) (8 11 9 7) (9 11 10 8) (10 11 6 9))! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:36'!
starEdges
	^ #((1 7) (7 2) (2 8) (8 3) (3 9) (9 4) (4 10) (10 5) (5 6) (6 1) (7 6) (8 7) (9 8) (10 9) (6 10) (6 11) (7 11) (8 11) (9 11) (10 11))
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:25'!
starHandles
	^" #(1 8 9  10)" #(1 2 3 4 5)
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:27'!
starVertices
	^  {250.0@150.0. 345.10565@219.0983. 308.77852@330.90169. 191.22147@330.90169. 154.89434@219.0983. 225.31301@216.02128. 274.68698@216.02128. 289.94437@262.34349. 250.0@292.0. 210.05562@262.34349. 250@250}! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 18:18'!
baseSetupA1: input

	a1 := (1 to: (edges size + handles size)) collect: [:e | FloatArray new: vertices size].
	self baseSetupA1Top: input.
	self baseSetupA1Bottom: input.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 19:20'!
baseSetupA1Bottom: input

	1 to: handles size do: [:h |
		| row |
		row := a1 at: edges size + h.
		row at: (handles at: h) put: 1000.
	].
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 18:21'!
baseSetupA1Top: input

	1 to: edges size do: [:e |
		| neighbor vi vj row |
		neighbor := neighbors at: e.
		vi := neighbor at: 1.
		vj := neighbor at: 2.
		row := a1 at: e. "(e - 1) * 2 + 1"

		row at: vi put: -1.
		row at: vj put: 1.
	].
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/20/2016 09:07'!
baseSolve: input
	| b a x y result t ti |
	self baseSetupA1: input.
	a := LapackSGEMatrix rows: a1.
	b :=  LapackSGEMatrix rows: (
		(edgeDiffs collect: [:e | {e x}]),
		(handles collect: [:h |
				{1000 * (input at: h ifAbsent: [vertices at: h]) x}])).
	"t := a transposed * a.
	 := reciprocal.
	result := * a transposed * b."
	t := a transposed * a.
	ti := t reciprocal.
	x := ti * a transposed * b.
	b :=  LapackSGEMatrix rows: (
		(edgeDiffs collect: [:e | {e y}]),
		(handles collect: [:h |
				{1000 * (input at: h ifAbsent: [vertices at: h]) y}])).
	t := a transposed * a.
	ti := t reciprocal.
	y := ti * a transposed * b.
	result := Array streamContents: [:st |
		1 to: vertices size do: [:r |
			st nextPut: (x at: r).
			st nextPut: (y at: r)]].
	self drawRectangle: result with: input.
	^ result.

! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 11:35'!
computeT2: i to: input
	| neighbor vi vj vl vr vid vjd vld vrd g gt vds t |
	neighbor := neighbors at: i.
	vi := (neighbor at: 1).
	vj := (neighbor at: 2)..
	vl := (neighbor at: 3)..
	vr := (neighbor at: 4).
	g := {
		{(vertices at: vi) x. (vertices at: vi) y}.
		{(vertices at: vi) y. ((vertices at: vi) x) negated}.
		{(vertices at: vj) x. (vertices at: vj) y}.
		{(vertices at: vj) y. ((vertices at: vj) x) negated}.
		{(vertices at: vl) x. (vertices at: vl) y}.
		{(vertices at: vl) y. ((vertices at: vl) x) negated}}.
	vid := input at: vi ifAbsent: [vertices at: vi].
	vjd := input at: vj ifAbsent: [vertices at: vj].
	vld := input at: vl ifAbsent: [vertices at: vl].
	vds := {
		{vid x}.
		{vid y}.
		{vjd x}.
		{vjd y}.
		{vld x}.
		{vld y}}.
	vr > 0 ifTrue: [
		g := g, {
			{(vertices at: vr) x. (vertices at: vr) y}.
			{(vertices at: vr) y. ((vertices at: vr) x) negated}}.
		vrd := input at: vr ifAbsent: [vertices at: vr].
		vds := vds, {
			{vrd x}.
			{vrd y}}].

	g :=  LapackSGEMatrix rows: g.
	vds := LapackSGEMatrix rows: vds.
	gt := g transposed.
	t := (gt * g) reciprocal * gt * vds.
	^ ((t at: 1)@(t at: 2))
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/20/2016 10:30'!
computeT: i to: input
	| neighbor vi vj vl vr g gt |
	neighbor := neighbors at: i.
	vi := (neighbor at: 1).
	vj := (neighbor at: 2)..
	vl := (neighbor at: 3)..
	vr := (neighbor at: 4).
	g := {
		{(vertices at: vi) x. (vertices at: vi) y}.
		{(vertices at: vi) y. ((vertices at: vi) x) negated}.
		{(vertices at: vj) x. (vertices at: vj) y}.
		{(vertices at: vj) y. ((vertices at: vj) x) negated}.
		{(vertices at: vl) x. (vertices at: vl) y}.
		{(vertices at: vl) y. ((vertices at: vl) x) negated}}.
	vr > 0 ifTrue: [
		g := g, {
			{(vertices at: vr) x. (vertices at: vr) y}.
			{(vertices at: vr) y. ((vertices at: vr) x) negated}}].
	g :=  LapackSGEMatrix rows: g.
	gt := g transposed.
	^  (gt * g) reciprocal * gt.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 16:22'!
drawRectangle: mat with: input
	| f c |
	self halt.
	f := Form extent: 300@300 depth: 32.
	f fillColor: Color white.
	c := f getCanvas.
	1 to: vertices size do: [:i |
		| p |
		p := (mat at: (i - 1) * 2 + 1)@(mat at: (i - 1) * 2 + 2).
		c fillRectangle: ((p - 8) extent: 16) color: Color black.
	].
	edges do: [:pair | | dest orig |
		orig := (mat at: (pair first - 1) * 2 + 1)@(mat at: (pair first - 1) * 2 + 2).
		dest := (mat at: (pair second - 1) * 2 + 1)@(mat at: (pair second - 1) * 2 + 2).
		c line: orig to: dest width: 2 color: Color gray.
	].
	f displayOn: Display.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 12:04'!
edges
	^ edges
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 13:52'!
handles
	^ handles
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 11:02'!
setupA12: input

	a1 := (1 to: 2 * (edges size + handles size)) collect: [:e | FloatArray new: 2 * vertices size].
	self setupA1Top2: input.
	self setupA1Bottom: input.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 11:02'!
setupA1: input

	a1 := (1 to: 2 * (edges size + handles size)) collect: [:e | FloatArray new: 2 * vertices size].
	self setupA1Top: input.
	self setupA1Bottom: input.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/20/2016 10:05'!
setupA1Bottom: input

	| edgeSize |
	edgeSize := 2 * edges size.
	1 to: handles size do: [:h |
		| xrow yrow |
		xrow := a1 at: edgeSize + ((h - 1) * 2 + 1).
		yrow := a1 at: edgeSize + ((h - 1) * 2 + 2).

		xrow at: ((handles at: h) - 1) * 2 + 1 put: 1000.
		yrow at: ((handles at: h) - 1) * 2 + 2 put: 1000.
	].
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 11:35'!
setupA1Top2: input

	1 to: edges size do: [:e |
		| neighbor h vi vj xrow yrow |
		neighbor := neighbors at: e.
		"ed := edgeDiffs at: e."
		h := {
			{-1. 0. 1. 0}.
			{0. -1. 0. 1}}.
		vi := neighbor at: 1.
		vj := neighbor at: 2.
		xrow := a1 at: e * 2 - 1. "(e - 1) * 2 + 1"
		yrow := a1 at: e * 2. "(e - 1) * 2 + 2."

		xrow at: (vi - 1)	* 2 + 1 put: ((h at: 1) at: 1).
		xrow at: (vi - 1) * 2 + 2 put: ((h at: 1) at: 2).
		yrow at: (vi - 1)	* 2 + 1 put: ((h at: 2) at: 1).
		yrow at: (vi - 1) * 2 + 2 put: ((h at: 2) at: 2).
	
		xrow at: (vj - 1) * 2 + 1 put: ((h at: 1) at: 3).
		xrow at: (vj - 1) * 2 + 2 put: ((h at: 1) at: 4)..
		yrow at: (vj - 1) * 2 + 1 put: ((h at: 2) at: 3)..
		yrow at: (vj - 1) * 2 + 2 put: ((h at: 2) at: 4).
	].
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 16:41'!
setupA1Top: input

	1 to: edges size do: [:e |
		| neighbor h t vi vj vl vr xrow yrow |
		neighbor := neighbors at: e.
		t := self computeT: e to: input.
		h := self step1Term: e with: t.
		vi := neighbor at: 1.
		vj := neighbor at: 2.
		vl := neighbor at: 3.
		vr := neighbor at: 4.
		xrow := a1 at: e * 2 - 1. "(e - 1) * 2 + 1"
		yrow := a1 at: e * 2. "(e - 1) * 2 + 2."

		vr > 0 ifTrue: [
			xrow at: (vi - 1)	* 2 + 1 put: (h at: 1).
			xrow at: (vi - 1) * 2 + 2 put: (h at: 2).
			yrow at: (vi - 1)	* 2 + 1 put: (h at: 9).
			yrow at: (vi - 1) * 2 + 2 put: (h at: 10).
	
			xrow at: (vj - 1) * 2 + 1 put: (h at: 3).
			xrow at: (vj - 1) * 2 + 2 put: (h at: 4).
			yrow at: (vj - 1) * 2 + 1 put: (h at: 11).
			yrow at: (vj - 1) * 2 + 2 put: (h at: 12).

			xrow at: (vl - 1)	* 2 + 1 put: (h at: 5).
			xrow at: (vl - 1) * 2 + 2 put: (h at: 6).
			yrow at: (vl - 1) * 2 + 1 put: (h at: 13).
			yrow at: (vl - 1) * 2 + 2 put: (h at: 14).

			xrow at: (vr - 1)	* 2 + 1 put: (h at: 7).
			xrow at: (vr - 1) * 2 + 2 put: (h at: 8).
			yrow at: (vr - 1) * 2 + 1 put: (h at: 15).
			yrow at: (vr - 1) * 2 + 2 put: (h at: 16)
		] ifFalse: [
			xrow at: (vi - 1)	* 2 + 1 put: (h at: 1).
			xrow at: (vi - 1) * 2 + 2 put: (h at: 2).
			yrow at: (vi - 1)	* 2 + 1 put: (h at: 7).
			yrow at: (vi - 1) * 2 + 2 put: (h at: 8).
	
			xrow at: (vj - 1) * 2 + 1 put: (h at: 3).
			xrow at: (vj - 1) * 2 + 2 put: (h at: 4).
			yrow at: (vj - 1) * 2 + 1 put: (h at: 9).
			yrow at: (vj - 1) * 2 + 2 put: (h at: 10).

			xrow at: (vl - 1)	* 2 + 1 put: (h at: 5).
			xrow at: (vl - 1) * 2 + 2 put: (h at: 6).
			yrow at: (vl - 1) * 2 + 1 put: (h at: 11).
			yrow at: (vl - 1) * 2 + 2 put: (h at: 12).
		].
	].
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 13:42'!
solve2: input
	| b a result t ti r |
	self setupA12: input.
	a := LapackSGEMatrix rows: a1.
	b :=  LapackSGEMatrix rows: (
		Array streamContents: [:row |
			1 to: edges size do: [:e |
				t := self computeT2: e to: input.
				r := t r.
				row nextPut: {((t x * (edgeDiffs at: e) x + (t y * (edgeDiffs at: e) y))) / r}.
				row nextPut: {((t y negated * (edgeDiffs at: e) x + (t x * (edgeDiffs at: e) y))) / r}
			].
			handles do: [:h |
				row nextPut: {1000 * (input at: h ifAbsent: [vertices at: h]) x}.
				row nextPut: {1000 * (input at: h ifAbsent: [vertices at: h]) y}]]).
	t := a transposed * a.
	ti := t reciprocal.
	result := ti * a transposed * b.
	"c := LapackLeastSquareProblem matrix: a rhsMatrix: b.
	result := c solution."
	"self drawRectangle: result with: input."
	^ result.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/20/2016 10:05'!
solve: input
	| b a c result t ti |
	self setupA1: input.
	a := LapackSGEMatrix rows: a1.
	b :=  LapackSGEMatrix rows: (
		((1 to: 2 * edges size) collect: [:e | #(0)]),
		(Array streamContents: [:bottomB |
			handles do: [:h |
				bottomB nextPut: {1000 * (input at: h ifAbsent: [vertices at: h]) x}.
				bottomB nextPut: {1000 * (input at: h ifAbsent: [vertices at: h]) y}]])).
		self halt.
	t := a transposed * a.
	ti := t reciprocal.
	result := ti * a transposed * b.
	"c := LapackLeastSquareProblem matrix: a rhsMatrix: b.
	result := c solution."
	self drawRectangle: result with: input.
	^ result.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 15:14'!
step1Term: e with: gtgig
	| a neighbor vi vj ek em h vl vr |
	neighbor := neighbors at: e.
	vi := neighbor at: 1.
	vj := neighbor at: 2.
	vl := neighbor at: 3.
	vr := neighbor at: 4.
	vr > 0 ifTrue: [
		a := LapackSGEMatrix rows: {
			{-1. 0. 1. 0. 0. 0. 0. 0}.
			{0. -1. 0. 1. 0. 0. 0. 0}}
	] ifFalse: [
		a := LapackSGEMatrix rows: {
			{-1. 0. 1. 0. 0. 0}.
			{0. -1. 0. 1. 0. 0}}].
		
	ek := edgeDiffs at: e.
	em :=  LapackSGEMatrix rows: {
			{ek x. ek y}.
			{ek y. ek x negated}}.
	h := a - (em * gtgig).
	^ h.
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 12:04'!
vertices
	^ vertices
! !

!Shape methodsFor: 'as yet unclassified' stamp: 'yo 8/19/2016 13:57'!
vertices: vs edges: es neighbors: ns handles: hs
	vertices := vs.
	edges := es.
	neighbors := ns.
	handles := hs.
	edgeDiffs := edges collect: [:pair | (vertices at: (pair at: 2)) - (vertices at: (pair at: 1))].! !
